[CCode (cheader_filename = "rc522.h")]
namespace RC522 {
	[CCode (cname = "InitRc522")]
	public void init ();
}

[CCode (cheader_filename = "rfid.h")]
namespace RFID {
	[CCode (cname = "find_tag")]
	public char find_tag (out uint16 card_type);
	[CCode (cname = "select_tag_sn")]
	public char select_tag_sn (out string str);
	[CCode (cname = "select_tag_sn")]
	public char read_tag_str (uint8 addr, ref char str);
}

[CCode (cprefix = "TAG_", has_type_id = false)]
public extern enum Tag {
	OK,
	NOTAG,
	ERR,
	ERRCRC,
	COLLISION;
}
