/*
 * rfid.c
 *
 *  Created on: 06.09.2013
 *      Author: alexs
 */
#include "rfid.h"



uint8_t buff[MAXRLEN];


tag_stat find_tag(uint16_t * card_type) {
	tag_stat tmp;
	if ((tmp=PcdRequest(PICC_REQIDL,buff))==TAG_OK) {
		*card_type=(int)(buff[0]<<8|buff[1]);
	}
	return tmp;
}

tag_stat select_tag_sn(gchar **uid){
    gchar* result = NULL;
	if (PcdAnticoll(PICC_ANTICOLL1,buff)!=TAG_OK) {return TAG_ERR;}
	if (PcdSelect(PICC_ANTICOLL1,buff)!=TAG_OK) {return TAG_ERR;}
	if (buff[0]==0x88) {
        result = g_strdup_printf ("%02x%02x%02x", buff[1], buff[2], buff[3]);
		if (PcdAnticoll(PICC_ANTICOLL2,buff)!=TAG_OK) {
			return TAG_ERR;}
		if (PcdSelect(PICC_ANTICOLL2,buff)!=TAG_OK) {return TAG_ERR;}
		if (buff[0]==0x88) {
            gchar* result_t = g_strdup_printf ("%s%02x%02x%02x", result, buff[0], buff[1], buff[2]);
            g_free (result);
            result = result_t;
			if (PcdAnticoll(PICC_ANTICOLL3,buff)!=TAG_OK) {
                *uid = result;
				return TAG_ERR;
            }

			if (PcdSelect(PICC_ANTICOLL3,buff)!=TAG_OK) {
                *uid = result;
                return TAG_ERR;
            }

            result_t = g_strdup_printf ("%s%02x%02x%02x%02x", result, buff[0], buff[1], buff[2], buff[3]);
            g_free (result);
            result = result_t;
		}else{
            gchar* result_t = g_strdup_printf ("%s%02x%02x%02x%02x", result, buff[0], buff[1], buff[2], buff[3]);
            g_free (result);
            result = result_t;
		}
	}else{
        result = g_strdup_printf ("%02x%02x%02x%02x", buff[0], buff[1], buff[2], buff[3]);
	}

    *uid = result;
	return TAG_OK;
}

tag_stat read_tag_str(uint8_t addr, char * str) {
	tag_stat tmp;
	char *p;
	uint8_t i;

	uint8_t buff[MAXRLEN];

	tmp=PcdRead(addr,buff);
	p=str;
	if (tmp==TAG_OK) {
		for (i=0;i<16;i++) {
			sprintf(p,"%02x",(char)buff[i]);
			p+=2;
		}
	}else if (tmp==TAG_ERRCRC){
		sprintf(p,"CRC Error");
	}else{
		sprintf(p,"Unknown error");
	}
	return tmp;
}


